## morph-browser 1.0.0+git20230204.ea69e43+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(morph-browser VERSION 1.0.0 LANGUAGES CXX)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

find_package(Gettext REQUIRED)

option(CLICK_MODE "Build as a click package" off)

# Standard install paths
include(GNUInstallDirs)

#set install paths
if(CLICK_MODE)
  set(CMAKE_INSTALL_PREFIX "/")
  set(CMAKE_INSTALL_BINDIR "/")
  set(CMAKE_INSTALL_FULL_DATADIR "./share")
  add_definitions("-DCLICK_MODE")
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

include(EnableCoverageReport)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage (or ninja if you use that backend)
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
if(cmake_build_type_lower MATCHES coverage)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage" )
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage" )
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage" )
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage" )
    ENABLE_COVERAGE_REPORT(EXCLUDES tests/*|.*moc_.*.cpp FILTER tests/* moc_*.cpp)
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

# enable QML debugging
if(CMAKE_BUILD_TYPE MATCHES DEBUG OR CMAKE_BUILD_TYPE MATCHES "Debug")
    add_definitions(-DQT_QML_DEBUG)
endif()

include(qt5)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

set(DESKTOP_FILE morph-browser.desktop)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)
add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

add_subdirectory(src)

enable_testing()
add_subdirectory(tests)

# make non compiled files (QML, JS, images, etc.) visible in QtCreator
file(GLOB NON_COMPILED_ROOT *.png .gitignore COPYING README snapcraft.yaml)
file(GLOB_RECURSE NON_COMPILED_SUBDIRS
     debian/*.dirs debian/*.install debian/*.lintian-overrides debian/*.manifest
     debian/compat debian/control debian/copyright debian/rules debian/source/format
     debian/tests/*
     doc/*.css doc/*.qdoc doc/*.qdocconf
     po/*.po po/*.pot
     snap/morph-browser.launcher
     src/*.js src/*.qml src/*.sci src/README
     tests/*.py tests/*.qml)
add_custom_target(NON_COMPILED_TARGET ALL SOURCES ${NON_COMPILED_ROOT} ${NON_COMPILED_SUBDIRS})

# for dh_translations to extract the domain
# (regarding syntax consistency, see http://pad.lv/1181187)
set (GETTEXT_PACKAGE "morph-browser")

add_subdirectory(po)

add_subdirectory(doc)

install(FILES morph-browser.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser)
install(FILES morph-browser-splash.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser)
add_subdirectory(click-hooks)

=== debian/changelog ===
morph-browser (1.0.0+git20230204.ea69e43+dfsg-1) unstable; urgency=medium

  * New upstream Git snapshot.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 04 Feb 2023 16:24:48 +0100

morph-browser (1.0.0+git20230201.8e6e8a0+dfsg-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1030393).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 04 Feb 2023 02:08:51 +0100

=== debian/control ===
Source: morph-browser
Section: x11
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>,
           Marius Gripsgard <marius@debian.org>,
Build-Depends: apparmor:native,
               apparmor-easyprof,
               cmake,
               debhelper-compat (= 13),
               dh-apparmor,
               libapparmor-dev,
               libqt5sql5-sqlite,
               lsb-release,
               pkg-config,
               python3-all:any,
               python3-flake8 (>= 2.2.2-1ubuntu4) | python3-flake8:native,
               qml-module-qt-labs-folderlistmodel,
               qml-module-qt-labs-settings,
               qml-module-qtquick2 (>= 5.4),
               qml-module-qtquick-controls2,
               qml-module-qtquick-layouts,
               qml-module-qtsysteminfo,
               qml-module-qttest,
               qml-module-qtwebengine,
               qml-module-lomiri-components,
               qml-module-lomiri-test,
               qml-module-lomiri-components-extras,
               qtbase5-dev (>= 5.4),
               qtbase5-dev-tools,
               qtdeclarative5-dev,
               qttools5-dev-tools,
               qtwebengine5-dev,
               xauth,
               xvfb,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/morph-browser
Vcs-Browser: https://salsa.debian.org/ubports-team/morph-browser
Vcs-Git: https://salsa.debian.org/ubports-team/morph-browser.git

Package: morph-browser
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         fonts-liberation,
         libqt5sql5-sqlite,
         libqt5webengine5,
         qml-module-qt-labs-folderlistmodel,
         qml-module-qt-labs-settings,
         qml-module-qtquick2 (>= 5.5),
         qml-module-qtquick-layouts,
         qml-module-qtquick-window2 (>= 5.3),
         qml-module-qtsysteminfo,
         qml-module-morph-web (= ${binary:Version}),
         qml-module-lomiri-content,
         qml-module-lomiri-components-extras,
         qml-module-lomiri-components,
         qml-module-lomiri-action,
Provides: www-browser
Description: Web Browser for Lomiri
 Lightweight web browser tailored for Lomiri, based on the Qt WebEngine
 and using the Lomiri UI components.

Package: morph-webapp-container
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         fonts-liberation,
         libqt5sql5-sqlite,
         libqt5webengine5,
         qml-module-qtquick2 (>= 5.5),
         qml-module-qtquick-window2 (>= 5.3),
         qml-module-sso-onlineaccounts,
         qml-module-morph-web (= ${binary:Version}),
         qml-module-lomiri-content,
         qml-module-lomiri-components,
         qml-module-lomiri-action,
         qml-module-lomiri-onlineaccounts-client,
         morph-browser (= ${binary:Version}),
Description: Morph web applications container
 Lightweight webapp container tailored for Lomiri, based on the
 Qt WebEngine and using the Lomiri UI components.

Package: qml-module-morph-web
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
         qml-module-qtwebengine,
         qml-module-qtquick2 (>= 5.4),
         qml-module-qtquick-window2 (>= 5.3),
         qml-module-lomiri-components,
Description: Morph web QML module
 Standalone QML module that contains the WebView component,
 in the Morph.Web namespace.

Package: qml-module-morph-web-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Morph web QML module (HTML documentation)
 A standalone QML module that contains the WebView component,
 in the Morph.Web namespace. This package contains the public
 HTML documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

BUILDHOME=/tmp/home

%:
	dh $@

apparmor:
	aa-easyprof -m ./debian/morph-browser-apparmor.manifest --no-verify | \
	egrep -v '(# Click packages|CLICK_DIR)' | \
	sed 's/@{APP_PKGNAME}_@{APP_APPNAME}_@{APP_VERSION}/@{APP_PKGNAME}/g' | \
	sed 's#/run/shm/\.org\.chromium\.Chromium\.\*#/{dev,run}/shm/.org.chromium.Chromium.*#g' | \
	egrep -v 'deny /run/udev/data/\*\* r,' | \
	sed 's#^}$$#\n  /sys/class/ r,\n  /sys/class/input/ r,\n  /run/udev/data/** r,\n}#g' | \
	egrep -v '^\s*deny /dev/ r,\s*$$' | \
	sed 's#^\(\s*\)deny\(\s\+/{run,dev}/shm/pulse-shm\*\s\+w,\).*$$#\1owner\2#g' | \
	sed 's#^}$$#\n  /dev/dri/ r,\n  /sys/devices/pci[0-9]*/**/config r,\n}#g' | \
	sed 's#^}$$#\n  @{HOME}/@{XDG_DOWNLOAD_DIR}/** rwk,\n}#g' \
	> ./debian/usr.bin.morph-browser
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	apparmor_parser -QTK ./debian/usr.bin.morph-browser
endif

override_dh_install: apparmor
	mkdir -p debian/tmp/usr/share/apparmor/hardware/audio.d/
	touch    debian/tmp/usr/share/apparmor/hardware/audio.d/.placeholder
	mkdir -p debian/tmp/usr/share/apparmor/hardware/graphics.d/
	touch    debian/tmp/usr/share/apparmor/hardware/graphics.d/.placeholder
	mkdir -p debian/tmp/usr/share/apparmor/hardware/video.d/
	touch    debian/tmp/usr/share/apparmor/hardware/video.d/.placeholder
	mv debian/tmp/usr/share/doc/morph-web debian/tmp/usr/share/doc/qml-module-morph-web
	rmdir debian/tmp/usr/share/doc/qml-module-morph-web/html/images
	dh_install

override_dh_missing:
	dh_missing --fail-missing

override_dh_installdeb:
	dh_apparmor --profile-name=usr.bin.morph-browser -pmorph-browser
	dh_installdeb

override_dh_clean:
	dh_clean
	rm -rf $(BUILDHOME)

override_dh_auto_test:
	mkdir -p $(BUILDHOME)
	HOME=$(BUILDHOME) dh_auto_test --no-parallel -- ARGS+=-VV

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, repacksuffix=+dfsg, dversionmangle=s/\+dfsg//, pretty=1.0.0+git%cd.%h" \
https://gitlab.com/ubports/development/core/morph-browser \
HEAD debian uupdate

## morph-browser 1.0.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(morph-browser VERSION 1.0.0 LANGUAGES CXX)
+project(morph-browser VERSION 1.0.1 LANGUAGES CXX)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

=== debian/changelog ===
morph-browser (1.0.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch:
    + Start watching upstream releases.
  * debian/control:
    + Disable build of morph-webapp-container bin:pkg for Debian bookworm. Too
      much effort to get the complete lomiri-online-accounts stack in before
      the freeze.
  * debian/rules:
    + Temporarily don't ship the files of morph-webapp-container.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 05 Feb 2023 14:04:30 +0100

=== debian/rules ===
--- 
+++ 
@@ -40,6 +40,13 @@
 	touch    debian/tmp/usr/share/apparmor/hardware/video.d/.placeholder
 	mv debian/tmp/usr/share/doc/morph-web debian/tmp/usr/share/doc/qml-module-morph-web
 	rmdir debian/tmp/usr/share/doc/qml-module-morph-web/html/images
+
+	# temporarily don't ship the files of morph-webapp-container
+	rm -v  debian/tmp/usr/bin/webapp-container
+	rm -Rv debian/tmp/usr/share/morph-browser/webcontainer/
+	rm -v  debian/tmp/usr/share/click/hooks/webapp-container.hook
+	rm -v  debian/tmp/usr/bin/webapp-container-hook
+
 	dh_install
 
 override_dh_missing:

## morph-browser 1.0.2%2Bdfsg

=== src/CMakeLists.txt ===
add_subdirectory(app)
add_subdirectory(Morph)

# DEPRECATED
add_subdirectory(Ubuntu)

=== tests/unittests/sanity/CMakeLists.txt ===
add_test(flake8 python3 -m flake8 ${autopilot-tests_SOURCE_DIR})

## morph-browser 1.0.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(morph-browser VERSION 1.0.1 LANGUAGES CXX)
+project(morph-browser VERSION 1.0.2 LANGUAGES CXX)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

=== src/app/CMakeLists.txt ===
project(webbrowser-common)

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(Qt5Quick REQUIRED)
find_package(Qt5Widgets REQUIRED)
#find_package(Qt5WebEngine REQUIRED)

include(FindPkgConfig)
pkg_check_modules(LIBAPPARMOR libapparmor REQUIRED)

configure_file(
    config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/config.h
    @ONLY)

set(COMMONLIB webbrowser-common)

set(COMMONLIB_SRC
    browserapplication.cpp
    browser-utils.cpp
    domain-permissions-model.cpp
    domain-settings-model.cpp
    domain-settings-sorted-model.cpp
    domain-settings-user-agents-model.cpp
    downloads-model.cpp
    favicon-fetcher.cpp
    file-operations.cpp
    input-method-handler.cpp
    meminfo.cpp
    mime-database.cpp
    session-storage.cpp
    single-instance-manager.cpp
)

add_library(${COMMONLIB} STATIC ${COMMONLIB_SRC})

include_directories(${LIBAPPARMOR_INCLUDE_DIRS})
target_link_libraries(${COMMONLIB}
    Qt5::Core
    Qt5::Gui
    Qt5::Network
    Qt5::Qml
    Qt5::Quick
    Qt5::Widgets
    Qt5WebEngine
    Qt5WebEngineCore
    ${LIBAPPARMOR_LDFLAGS}
)

file(GLOB QML_FILES *.qml qmldir)
install(FILES ${QML_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser)
file(GLOB JS_FILES *.js)
install(FILES ${JS_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser)
install(DIRECTORY actions DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser
        FILES_MATCHING PATTERN *.qml)

add_subdirectory(webbrowser)
add_subdirectory(webcontainer)

=== src/app/webbrowser/CMakeLists.txt ===
project(morph-browser)

find_package(Qt5Concurrent REQUIRED)
find_package(Qt5Sql REQUIRED)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${webbrowser-common_SOURCE_DIR}
    ${webbrowser-common_BINARY_DIR}
)

set(WEBBROWSER_APP_MODELS_SRC
    bookmarks-model.cpp
    bookmarks-folder-model.cpp
    bookmarks-folderlist-model.cpp
    history-domain-model.cpp
    history-domainlist-model.cpp
    history-lastvisitdatelist-model.cpp
    history-model.cpp
    limit-proxy-model.cpp
    tabs-model.cpp
    text-search-filter-model.cpp
)

set(WEBBROWSER_APP_MODELS morph-browser-models)

add_library(${WEBBROWSER_APP_MODELS} STATIC ${WEBBROWSER_APP_MODELS_SRC})
target_link_libraries(${WEBBROWSER_APP_MODELS}
    Qt5::Core
    Qt5::Sql
#    Qt5::WebEngine
)

set(WEBBROWSER_APP_SRC
    reparenter.cpp
    searchengine.cpp
    morph-browser.cpp
)

set(WEBBROWSER_APP morph-browser)

add_executable(${WEBBROWSER_APP} ${WEBBROWSER_APP_SRC})
target_link_libraries(${WEBBROWSER_APP}
    Qt5::Concurrent
    Qt5::Core
    Qt5::Qml
    Qt5::Quick
    ${COMMONLIB}
    ${WEBBROWSER_APP_MODELS}
)

install(TARGETS ${WEBBROWSER_APP}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

file(GLOB QML_FILES *.qml qmldir *.js)
install(FILES ${QML_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webbrowser)

install(DIRECTORY assets
        DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webbrowser
        FILES_MATCHING PATTERN *.png PATTERN *.svg PATTERN *.sci)

install(DIRECTORY searchengines
        DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webbrowser
        FILES_MATCHING PATTERN *.xml)

configure_file(${DESKTOP_FILE}.in.in ${DESKTOP_FILE}.in @ONLY)
add_custom_target(${DESKTOP_FILE} ALL
    COMMENT "Merging translations into ${DESKTOP_FILE}"
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
            --desktop --template=${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}.in
            -o ${DESKTOP_FILE}
            -d ${CMAKE_SOURCE_DIR}/po
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}
        DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)

install(FILES "morph-browser.url-dispatcher"
        DESTINATION ${CMAKE_INSTALL_DATADIR}/lomiri-url-dispatcher/urls)

install(FILES "morph-browser-content-hub.json"
    DESTINATION ${CMAKE_INSTALL_DATADIR}/content-hub/peers
    RENAME morph-browser
    )

if(${CLICK_MODE})
  message("-- Configuring manifest.json")

  execute_process(
    COMMAND dpkg-architecture -qDEB_HOST_ARCH
    OUTPUT_VARIABLE CLICK_ARCH
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )

  configure_file(manifest.json.in ${CMAKE_CURRENT_BINARY_DIR}/manifest.json)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/manifest.json DESTINATION ${CMAKE_INSTALL_PREFIX})
  install(FILES morph-browser.apparmor DESTINATION ${CMAKE_INSTALL_PREFIX})
endif()

=== tests/unittests/bookmarks-folderlist-model/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_BookmarksFolderListModelTests)
add_executable(${TEST} tst_BookmarksFolderListModelTests.cpp)
include_directories(${morph-browser_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Sql
    Qt5::Test
    morph-browser-models
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})

=== tests/unittests/history-lastvisitdatelist-model/CMakeLists.txt ===
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_HistoryLastVisitDateListModelTests)
add_executable(${TEST} tst_HistoryLastVisitDateListModelTests.cpp)
include_directories(${webbrowser-common_SOURCE_DIR} ${morph-browser_SOURCE_DIR})
target_link_libraries(${TEST}
    morph-browser-models
    Qt5::Sql
    Qt5::Test
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})

=== tests/unittests/history-model/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_HistoryModelTests)
add_executable(${TEST} tst_HistoryModelTests.cpp)
include_directories(${morph-browser_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Sql
    Qt5::Test
    morph-browser-models
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})

=== tests/unittests/limit-proxy-model/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_LimitProxyModelTests)
add_executable(${TEST} tst_LimitProxyModelTests.cpp)
include_directories(${morph-browser_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Sql
    Qt5::Test
    morph-browser-models
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})

=== tests/unittests/qml/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(Qt5Quick REQUIRED)
find_package(Qt5QuickTest REQUIRED)
find_package(Qt5Sql REQUIRED)

find_program(XVFBRUN xvfb-run)
if(NOT XVFBRUN)
  message(FATAL_ERROR "Could not find xvfb-run, please install the xvfb package")
endif()
set(XVFB_COMMAND ${XVFBRUN} -s "-screen 0 640x480x24" -a)

set(TEST tst_QmlTests)
set(SOURCES
    ${webbrowser-common_SOURCE_DIR}/favicon-fetcher.cpp
    ${morph-browser_SOURCE_DIR}/bookmarks-model.cpp
    ${morph-browser_SOURCE_DIR}/bookmarks-folder-model.cpp
    ${morph-browser_SOURCE_DIR}/bookmarks-folderlist-model.cpp
    ${webbrowser-common_SOURCE_DIR}/file-operations.cpp
    ${morph-browser_SOURCE_DIR}/history-domain-model.cpp
    ${morph-browser_SOURCE_DIR}/history-domainlist-model.cpp
    ${morph-browser_SOURCE_DIR}/history-model.cpp
    ${morph-browser_SOURCE_DIR}/history-lastvisitdatelist-model.cpp
    ${morph-browser_SOURCE_DIR}/limit-proxy-model.cpp
    ${morph-browser_SOURCE_DIR}/reparenter.cpp
    ${morph-browser_SOURCE_DIR}/searchengine.cpp
    ${morph-browser_SOURCE_DIR}/tabs-model.cpp
    ${morph-browser_SOURCE_DIR}/text-search-filter-model.cpp
    tst_QmlTests.cpp
)
add_executable(${TEST} ${SOURCES})
include_directories(
    ${webbrowser-common_SOURCE_DIR}
    ${morph-browser_SOURCE_DIR}
    ${unity8_SOURCE_DIR}/plugins
)
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Gui
    Qt5::Network
    Qt5::Qml
    Qt5::Quick
    Qt5::QuickTest
    Qt5::Sql
)
add_test(${TEST} ${XVFB_COMMAND} ${CMAKE_CURRENT_BINARY_DIR}/${TEST}
         -input ${CMAKE_CURRENT_SOURCE_DIR}
         -import ${CMAKE_BINARY_DIR}/src)

=== tests/unittests/search-engine/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_SearchEngineTests)
set(SOURCES
    ${morph-browser_SOURCE_DIR}/searchengine.cpp
    tst_SearchEngineTests.cpp
)
add_executable(${TEST} ${SOURCES})
include_directories(${morph-browser_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Test
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})

=== tests/unittests/single-instance-manager/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_SingleInstanceManagerTests)
set(SOURCES
    ${webbrowser-common_SOURCE_DIR}/single-instance-manager.cpp
    tst_SingleInstanceManagerTests.cpp
)
add_executable(${TEST} ${SOURCES})
include_directories(${webbrowser-common_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Network
    Qt5::Test
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})
set_tests_properties(${TEST} PROPERTIES ENVIRONMENT "QT_QPA_PLATFORM=minimal")

=== tests/unittests/tabs-model/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(Qt5Quick REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_TabsModelTests)
add_executable(${TEST} tst_TabsModelTests.cpp)
include_directories(${morph-browser_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Qml
    Qt5::Quick
    Qt5::Sql
    Qt5::Test
    morph-browser-models
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})
set_tests_properties(${TEST} PROPERTIES ENVIRONMENT "QT_QPA_PLATFORM=minimal")

=== debian/changelog ===
morph-browser (1.0.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Translation udpates.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 28 Feb 2023 19:50:01 +0100

morph-browser (1.0.1+dfsg-2) unstable; urgency=medium

  * debian/rules:
    + Drop .placeholder files in apparmor directories, only ship the empty
      directories. (Closes: #1030700).
    + Also ship empty etc/apparmor.d/ directory.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 06 Feb 2023 18:44:05 +0100

=== debian/control ===
--- 
+++ 
@@ -63,26 +63,29 @@
  Lightweight web browser tailored for Lomiri, based on the Qt WebEngine
  and using the Lomiri UI components.
 
-Package: morph-webapp-container
-Architecture: any
-Multi-Arch: foreign
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-         fonts-liberation,
-         libqt5sql5-sqlite,
-         libqt5webengine5,
-         qml-module-qtquick2 (>= 5.5),
-         qml-module-qtquick-window2 (>= 5.3),
-         qml-module-sso-onlineaccounts,
-         qml-module-morph-web (= ${binary:Version}),
-         qml-module-lomiri-content,
-         qml-module-lomiri-components,
-         qml-module-lomiri-action,
-         qml-module-lomiri-onlineaccounts-client,
-         morph-browser (= ${binary:Version}),
-Description: Morph web applications container
- Lightweight webapp container tailored for Lomiri, based on the
- Qt WebEngine and using the Lomiri UI components.
+# FIXME: Disable for the bookworm release. This needs lomiri-online-accounts
+#        and lomiri-system-settings-online-accounts to be provided in Debian.
+#
+#Package: morph-webapp-container
+#Architecture: any
+#Multi-Arch: foreign
+#Depends: ${misc:Depends},
+#         ${shlibs:Depends},
+#         fonts-liberation,
+#         libqt5sql5-sqlite,
+#         libqt5webengine5,
+#         qml-module-qtquick2 (>= 5.5),
+#         qml-module-qtquick-window2 (>= 5.3),
+#         qml-module-sso-onlineaccounts,
+#         qml-module-morph-web (= ${binary:Version}),
+#         qml-module-lomiri-content,
+#         qml-module-lomiri-components,
+#         qml-module-lomiri-action,
+#         qml-module-lomiri-onlineaccounts-client,
+#         morph-browser (= ${binary:Version}),
+#Description: Morph web applications container
+# Lightweight webapp container tailored for Lomiri, based on the
+# Qt WebEngine and using the Lomiri UI components.
 
 Package: qml-module-morph-web
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -32,12 +32,6 @@
 endif
 
 override_dh_install: apparmor
-	mkdir -p debian/tmp/usr/share/apparmor/hardware/audio.d/
-	touch    debian/tmp/usr/share/apparmor/hardware/audio.d/.placeholder
-	mkdir -p debian/tmp/usr/share/apparmor/hardware/graphics.d/
-	touch    debian/tmp/usr/share/apparmor/hardware/graphics.d/.placeholder
-	mkdir -p debian/tmp/usr/share/apparmor/hardware/video.d/
-	touch    debian/tmp/usr/share/apparmor/hardware/video.d/.placeholder
 	mv debian/tmp/usr/share/doc/morph-web debian/tmp/usr/share/doc/qml-module-morph-web
 	rmdir debian/tmp/usr/share/doc/qml-module-morph-web/html/images

## morph-browser 1.1.0%2Bdfsg

=== src/app/webcontainer/CMakeLists.txt ===
project(webapp-container)

find_package(Qt5DBus REQUIRED)
find_package(Qt5Sql REQUIRED)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${webbrowser-common_SOURCE_DIR}
    ${webbrowser-common_BINARY_DIR}
)

set(WEBAPP_CONTAINER webapp-container)

set(WEBAPP_CONTAINER_SRC
    chrome-cookie-store.cpp
    cookie-store.cpp
    online-accounts-cookie-store.cpp
    oxide-cookie-helper.cpp
    local-cookie-store.cpp
    webapp-container.cpp
    webapp-container-helper.cpp
    session-utils.cpp
    url-pattern-utils.cpp
    scheme-filter.cpp
    intent-parser.cpp
)

add_executable(${WEBAPP_CONTAINER} ${WEBAPP_CONTAINER_SRC})

target_link_libraries(${WEBAPP_CONTAINER}
    Qt5::Core
    Qt5::DBus
    Qt5::Gui
    Qt5::Qml
    Qt5::Quick
    Qt5::Sql
    ${COMMONLIB}
)

install(TARGETS ${WEBAPP_CONTAINER}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

file(GLOB QML_FILES *.qml *.js)
install(FILES ${QML_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webcontainer)
install(DIRECTORY actions DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webcontainer
        FILES_MATCHING PATTERN *.qml)

install(DIRECTORY assets
        DESTINATION ${CMAKE_INSTALL_DATADIR}/morph-browser/webcontainer
        FILES_MATCHING PATTERN *.png)

=== tests/unittests/favicon-fetcher/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_FaviconFetcherTests)
set(SOURCES
    ${webbrowser-common_SOURCE_DIR}/favicon-fetcher.cpp
    tst_FaviconFetcherTests.cpp
)
add_executable(${TEST} ${SOURCES})
include_directories(${webbrowser-common_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Gui
    Qt5::Network
    Qt5::Test
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})
set_tests_properties(${TEST} PROPERTIES ENVIRONMENT "QT_QPA_PLATFORM=minimal")

=== tests/unittests/history-domain-model/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_HistoryDomainModelTests)
add_executable(${TEST} tst_HistoryDomainModelTests.cpp)
include_directories(${morph-browser_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Sql
    Qt5::Test
    morph-browser-models
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})

=== debian/watch ===
version=4
opts="repacksuffix=+dfsg, dversionmangle=s/\+dfsg//" \
https://gitlab.com/ubports/development/core/morph-browser/tags .*/morph-browser-(\d\S+)\.tar\.gz

## morph-browser 1.1.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(morph-browser VERSION 1.0.2 LANGUAGES CXX)
+project(morph-browser VERSION 1.1.0 LANGUAGES CXX)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

=== src/app/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,7 @@
 find_package(Qt5Network REQUIRED)
 find_package(Qt5Qml REQUIRED)
 find_package(Qt5Quick REQUIRED)
+find_package(Qt5Sql REQUIRED)
 find_package(Qt5Widgets REQUIRED)
 #find_package(Qt5WebEngine REQUIRED)
 
@@ -33,6 +34,7 @@
     mime-database.cpp
     session-storage.cpp
     single-instance-manager.cpp
+    url-utils.cpp
 )
 
 add_library(${COMMONLIB} STATIC ${COMMONLIB_SRC})
@@ -44,6 +46,7 @@
     Qt5::Network
     Qt5::Qml
     Qt5::Quick
+    Qt5::Sql
     Qt5::Widgets
     Qt5WebEngine
     Qt5WebEngineCore

=== tests/unittests/bookmarks-folder-model/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_BookmarksFolderModelTests)
add_executable(${TEST} tst_BookmarksFolderModelTests.cpp)
include_directories(${morph-browser_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Sql
    Qt5::Test
    morph-browser-models
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})

=== tests/unittests/bookmarks-model/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_BookmarksModelTests)
add_executable(${TEST} tst_BookmarksModelTests.cpp)
include_directories(${morph-browser_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Sql
    Qt5::Test
    morph-browser-models
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})

=== tests/unittests/downloads-model/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_DownloadsModelTests)
add_executable(${TEST} tst_DownloadsModelTests.cpp)
include_directories(${webbrowser-common_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Sql
    Qt5::Test
    webbrowser-common
    morph-browser-models
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})
set_tests_properties(${TEST} PROPERTIES ENVIRONMENT "QT_QPA_PLATFORM=minimal")

=== tests/unittests/history-domainlist-model/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_HistoryDomainListModelTests)
add_executable(${TEST} tst_HistoryDomainListModelTests.cpp)
include_directories(${morph-browser_SOURCE_DIR} ${webbrowser-common_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Sql
    Qt5::Test
    morph-browser-models
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})

=== tests/unittests/qml/CMakeLists.txt ===
--- 
+++ 
@@ -19,6 +19,7 @@
     ${morph-browser_SOURCE_DIR}/bookmarks-folder-model.cpp
     ${morph-browser_SOURCE_DIR}/bookmarks-folderlist-model.cpp
     ${webbrowser-common_SOURCE_DIR}/file-operations.cpp
+    ${webbrowser-common_SOURCE_DIR}/url-utils.cpp
     ${morph-browser_SOURCE_DIR}/history-domain-model.cpp
     ${morph-browser_SOURCE_DIR}/history-domainlist-model.cpp
     ${morph-browser_SOURCE_DIR}/history-model.cpp

=== tests/unittests/text-search-filter-model/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_TextSearchFilterModelTests)
add_executable(${TEST} tst_TextSearchFilterModelTests.cpp)
include_directories(${morph-browser_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Sql
    Qt5::Test
    morph-browser-models
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})

=== tests/unittests/url-utils/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
set(TEST tst_UrlUtilsTests)
add_executable(${TEST} tst_UrlUtilsTests.cpp)
include_directories(${morph-browser_SOURCE_DIR} ${webbrowser-common_SOURCE_DIR})
target_link_libraries(${TEST}
    Qt5::Core
    Qt5::Sql
    Qt5::Test
    webbrowser-common
)
add_test(${TEST} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})
set_tests_properties(${TEST} PROPERTIES ENVIRONMENT "QT_QPA_PLATFORM=minimal")

=== debian/changelog ===
morph-browser (1.1.0+dfsg-2) unstable; urgency=medium

  * debian/control:
    + Add D (morph-browser): qml-module-qtquick-controls2. (Closes: #1067808).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 27 Mar 2024 08:23:12 +0100

morph-browser (1.1.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update copyright attribution for debian/.
    + Update copyright attributions.
    + Update auto-generated copyright.in file.
  * debian/patches:
    + Rebase 2001_skip-Ubuntu-compat-QML.patch.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 02 Feb 2024 13:47:55 +0100

=== debian/control ===
--- 
+++ 
@@ -50,6 +50,7 @@
          qml-module-qt-labs-folderlistmodel,
          qml-module-qt-labs-settings,
          qml-module-qtquick2 (>= 5.5),
+         qml-module-qtquick-controls2,
          qml-module-qtquick-layouts,
          qml-module-qtquick-window2 (>= 5.3),
          qml-module-qtsysteminfo,

## morph-browser 1.1.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(morph-browser VERSION 1.1.0 LANGUAGES CXX)
+project(morph-browser VERSION 1.1.1 LANGUAGES CXX)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
@@ -77,9 +77,7 @@
      tests/*.py tests/*.qml)
 add_custom_target(NON_COMPILED_TARGET ALL SOURCES ${NON_COMPILED_ROOT} ${NON_COMPILED_SUBDIRS})
 
-# for dh_translations to extract the domain
-# (regarding syntax consistency, see http://pad.lv/1181187)
-set (GETTEXT_PACKAGE "morph-browser")
+set(GETTEXT_PACKAGE "morph-browser")
 
 add_subdirectory(po)

=== tests/unittests/history-domainlist-model/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 find_package(Qt5Test REQUIRED)
 set(TEST tst_HistoryDomainListModelTests)
 add_executable(${TEST} tst_HistoryDomainListModelTests.cpp)
-include_directories(${morph-browser_SOURCE_DIR} ${webbrowser-common_SOURCE_DIR})
+include_directories(${webbrowser-app_SOURCE_DIR} ${webbrowser-common_SOURCE_DIR})
 target_link_libraries(${TEST}
     Qt5::Core
     Qt5::Sql

=== debian/changelog ===
morph-browser (1.1.1+dfsg-5) unstable; urgency=medium

  * debian/patches:
    + Add 0001_fix-is-not-supported-css-selector.patch. Resolves viewing
      GitLab and other responsive websites.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 01 Dec 2024 14:02:31 +0100

morph-browser (1.1.1+dfsg-4) unstable; urgency=medium

  [ Guido Berhoerster ]
  * debian/:
    + Disable apparmor profile generation

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 22 Oct 2024 22:35:56 +0200

morph-browser (1.1.1+dfsg-3) unstable; urgency=medium

  * debian/patches:
    + Rebase 2000_skip-flawed-tests.patch.
    + Add 2003_test-waiting-adjust-to-slow-archs.patch. Try to work-around
      test failure on mips64el.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 29 Sep 2024 21:37:50 +0200

morph-browser (1.1.1+dfsg-2) unstable; urgency=medium

  * debian/rules:
    + Ignore unit test failures on mip64el architecture. (Closes: #1074221).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 21 Sep 2024 09:28:54 +0200

morph-browser (1.1.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 0001_lomiri-content-hub.patch. Applied upstream.
  * debian/control:
    + Bump Standards-Version to 4.7.0. No changes needed.
  * debian/morph-browser.install:
    + Adjust to new lomiri-content-hub namespace.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 20 Sep 2024 23:50:02 +0200

morph-browser (1.1.0+dfsg-3) unstable; urgency=medium

  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.
  * debian/patches:
    + Add 0001_lomiri-content-hub.patch. Adapt to new content hub namespace.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 19 Sep 2024 09:47:08 +0200

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,12 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
+
+# Skip tests on mips64el. The QmlTests crash with segmentation fault at various
+# places which makes one guess that there is something odd going on with the
+# QmlTest test suite... No deeper motivation to hunt this down on an architecture
+# where Lomiri et al. will probably never used on.
+testskip_architectures := mips64el
 
 BUILDHOME=/tmp/home
 
@@ -31,7 +37,7 @@
 	apparmor_parser -QTK ./debian/usr.bin.morph-browser
 endif
 
-override_dh_install: apparmor
+override_dh_install: # apparmor
 	mv debian/tmp/usr/share/doc/morph-web debian/tmp/usr/share/doc/qml-module-morph-web
 	rmdir debian/tmp/usr/share/doc/qml-module-morph-web/html/images
 
@@ -47,7 +53,7 @@
 	dh_missing --fail-missing
 
 override_dh_installdeb:
-	dh_apparmor --profile-name=usr.bin.morph-browser -pmorph-browser
+#	dh_apparmor --profile-name=usr.bin.morph-browser -pmorph-browser
 	dh_installdeb
 
 override_dh_clean:
@@ -56,7 +62,12 @@
 
 override_dh_auto_test:
 	mkdir -p $(BUILDHOME)
+ifneq (,$(filter $(DEB_HOST_ARCH),$(testskip_architectures)))
 	HOME=$(BUILDHOME) dh_auto_test --no-parallel -- ARGS+=-VV
+else
+	# FIXME: Temporarily ignore unit test failures on testskip_architectures
+	-HOME=$(BUILDHOME) dh_auto_test --no-parallel -- ARGS+=-VV
+endif
 
 get-orig-source:
 	uscan --noconf --force-download --rename --download-current-version --destdir=..
